#ifndef BLUEPRINT_H_
#define BLUEPRINT_H_

#include "object.h"
#include "func.h"

Box(blueprint *,bp,Blueprint)

object * make_Blueprint(int32_t type_id);

int32_t _internal_blueprint_eq(object * left, object * right);
int32_t _internal_blueprint_rawsize(object * bp);

#define ldec_Build lvar(blueprint *, bp)
LocalsType(ldec_Build, Build)


#define ldec_BlueprintSP_Of lvar(blueprint *, bp)
LocalsType(ldec_BlueprintSP_Of ,BlueprintSP_Of)

#define ldec_ID lvar(object *, id)
LocalsType(ldec_ID, ID)

#define ldec_BlueprintSP_FromSP_ID lvar(uint32_t, type)
LocalsType(ldec_BlueprintSP_FromSP_ID, BlueprintSP_FromSP_ID)

#endif //BLUEPRINT_H_
